/*-------------------------------------------------------------------------*/
/* PAUSEIT:                             Copywrite 1990:  JMTS CONSULTANTS  */  
/*                                                                         */  
/*         This program may be used in a bat file to pause execution       */  
/*         for a variable amount of time.                                  */
/*                                                                         */
/*         It will display a user defined message and pass an errorlevel   */
/*         code of 0 or 1 depending on the user response.                  */
/*                                                                         */  
/*         If a key is pressed before the time expires, an errorlevel of   */  
/*         1 will be passed to DOS.                                        */  
/*                                                                         */  
/*         The call sequence is:     PAUSEIT 10 "YOUR MSG FOR PAUSE"       */  
/*                                                                         */  
/*-------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

main(argc,argv)
     int argc;
     char **argv;
{
     char *cpyrt = "Copywrite 1990 JMTS CONSULTANTS";
     char *msg   = "Strike a key when ready ...";
     int  rc     = 0;                       /* return code to dos          */
     int  pause  = 0;                       /* timeout value               */
     time_t start;                          /* when the clock started      */

     if (argc == 2)                         /* timeout is on command line  */
             pause = atoi(argv[1]);         /* convert                     */

     if (pause == 0)                        /* not on cmd line or improper */
             pause = 10;                    /* default timeout             */

     if (argc == 3)                         /* use user message if passed  */
             msg = argv[2];                 /* on the command line         */

     printf("%s\n",msg);                    /* output message              */

     start = time(NULL);                    /* the clock is running        */

     while ( (rc == 0) && ((time(NULL) - start) < pause))
        { if ( kbhit() )   rc = 1;          /* errorlevel = 1 to dos       */
	}

     exit(rc);
}
